﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace WpfApplication2
{
    class ViewModel : INotifyPropertyChanged
    {
        public ViewModel()
        {
            SetLables();
            AddDepartments();
        }

        private string _Column1Text;

        public string Column1Text
        {
            get { return _Column1Text; }
            set { _Column1Text = value;
            OnPropertyChanged("Column1Text");
            }
        }

        private string _Column2Text;

        public string Column2Text
        {
            get { return _Column2Text; }
            set { _Column2Text = value; OnPropertyChanged("Column2Text"); }
        }

        private string _Column3Text;

        public string Column3Text
        {
            get { return _Column3Text; }
            set
            {
                _Column3Text = value;
                OnPropertyChanged("Column3Text");
            }
        }

        private string _Column4Text;

        public string Column4Text
        {
            get { return _Column4Text; }
            set { _Column4Text = value; OnPropertyChanged("Column4Text"); }
        }

        #region INotifyPropertyChanged
        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        private List<Department> _Departments;

        public List<Department> Departments
        {
            get { return _Departments; }
            set { _Departments = value; }
        }

        void SetLables()
        {
            Column1Text = "Dept Id";
            Column2Text = "Dept Name";
            Column3Text = "Emp Id";
            Column4Text = "Emp Name";
        }
        
        void AddDepartments()
        {
            _Departments = new List<Department>()
            {
               new Department(){
                  DeptId = 1,
                  DeptName = "Competer",
                  Employees = new List<Employee>()
               },
               new Department(){
                  DeptId = 2,
                  DeptName = "Science",
                  Employees = null
               },
            };

            _Departments[0].Employees.Add(new Employee() { EmployeeId=1, EmployeeName="Test"});
        }


        #endregion
    }

    
}
